'''
    Copyright 2014 Benjamin Schwendemann <bschwendemann@ernw.de>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions are
    met:
       
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
      copyright notice, this list of conditions and the following disclaimer
      in the documentation and/or other materials provided with the
      distribution.
    * Neither the name of the  nor the names of its
      contributors may be used to endorse or promote products derived from
      this software without specific prior written permission.
       
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
    OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
'''

import base64
import sys
import time
from PIL import Image
from io import BytesIO
from qrtools import QR

inputFileName = "input"
outputFileName = "output"
prompt = '> '

print "Input File? (Default: '%s')" % inputFileName
newInFileName = raw_input(prompt)
if newInFileName != '':
	inputFileName = newInFileName

print "Output File? (Default: '%s')" % outputFileName
newOutFileName = raw_input(prompt)
if newOutFileName != '':
	outputFileName = newOutFileName

inFile = open(inputFileName, "r")

outFile = open(outputFileName, "w")
outFile.close()
outFile = open(outputFileName, "a")

ts = time.time()
processed = 0

sys.stdout.write("Start...\n ")

for line in inFile:
	im = Image.open(BytesIO(base64.b64decode(line)))
	im.save('temp_qr.png', 'PNG')
	qrCode = QR(filename=u"temp_qr.png")
	if qrCode.decode():
		outFile.write(qrCode.data + "\n")
		processed += 1
	if time.time() - ts > 1:
		ts = time.time()
		sys.stdout.write("\rQR-Codes processed: %7d" % processed)
		sys.stdout.flush()

sys.stdout.write("\rQR-Codes processed: %7d" % processed)
print "\nDone"

outFile.close()
inFile.close()
